/**
 *  KeyInput.h
 *  
 *  A very simple and abstract class that represents any UIElement dealing in key input.
 *
 *  In application, the parent container could refer key input to a key input object via pointer. This pointer could be changed to point to a different KeyInput object whenever key layouts change (KeyInput * currentKeyInput).
 *
 *  Use this class as parent to any key layout class you define (TitleScreenKeyInput, FightingKeyInput, etc.)
 *
 *  Created by Jaeder Patater on 8/12/05.
 *  Copyright 2005. All rights reserved.
 *
 */

#ifndef KEY_INPUT_H
#define KEY_INPUT_H

#include <stdio.h>

#include "UIElement.h"

class KeyInput : public UIElement {
protected:
    KeyInput();             //default constructor
    
public:
    virtual ~KeyInput();    //destructor
    KeyInput(const KeyInput & other);           //copy constructor
    KeyInput operator=(const KeyInput & other); //= operator
    
    /**
     *  recieveEvent(UIEvent * event);
     *
     *  Recieves a UIEvent and calls the appropriate handler.
     *
     *  Use this method to supply your own key input configuration
     *
     */
    virtual void recieveEvent(UIEvent * event);
    
};

#endif

