#include <nds.h>
#include <fat.h>
#include <nds/arm9/console.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "ndsload.h"

//gui kit includes
#include "Guikit.h"

//Homemade UIElement includes (usually screens and other top level containers; main shouldn't be messing with other kinds of elements)


//Extra Vblank thingy added by Poffy
volatile int frame = 0; //Patater guesses this is similar to heartbeat, but without using IPC

void Vblank() {
	frame++;
}

//////////////////////////////////////////////////////

int main(void) {
	powerON(POWER_ALL);
	
	// Initialize and enable VBlank and other interrupts
	irqInit();
	//VBlank interrupt added by Poffy (next two lines)
	irqSet(IRQ_VBLANK, Vblank);
	irqEnable(IRQ_VBLANK);
	
	//init filesystem
	//below may be correct, but due to a probable typo in libnds (registers_alt.h:90) we use a different line
    //REG_EXEMEMCNT &= ~(0x8080); //still needed? dangerous? will it work without this?
    REG_EXMEMCNT &= ~(0x8080);
    fatInitDefault();

	/*
	lcdSwap(); //swap main and sub position (we want main on bottom and sub on top)
	
	//create the screens
	Screen * subScreen = new Screen(SUB, CONSOLE);
	subScreen->initializeConsolePrint(RGB15(22, 1, 22));
	consoleClear();
	iprintf("\x1b[2J");
	
	Screen * mainScreen = new Screen(MAIN, M5_EXROT_BG_256P_256PX);
	mainScreen->initializeDisplay();
	BG_PALETTE[255] = 0x0000; //black bg
	mainScreen->fillBackground((uint8)0x00, SCREEN_WIDTH * SCREEN_HEIGHT);
	
	swiWaitForVBlank();
	
	iprintf("GUIKit Release 2006 July 10\nHappy Birthday Mr.Poffenberger!\nStart + Select to exit.\n\n");
	
	bool running = true;
	iprintf("running...");
	
	//main operations loop
	while (running) {
		Guikit::updateInput();
		
		if ((keysHeld() & KEY_SELECT) && (keysHeld() & KEY_START)) {
			running = false;
		}
		
		mainScreen->recieveEvent(Guikit::handleInput()); //guikit generates events to be handled by the top level container
		
		swiWaitForVBlank();
	}
	
	iprintf("done.\n");
	iprintf("exiting...\n");
	
	delete subScreen;
	delete mainScreen;
	*/
	//booter code
	Guikit::bootNDS("/neos_kosmos.nds");
	
	return 0; //assuming here is unreachable
}

