/*
 *  GuiKit.cpp
 *  
 *
 *  Created by Jaeder Patater on 7/9/06.
 *  Copyright 2006. All rights reserved.
 *
 */

#include "Guikit.h"

int Guikit::temp = 0;
uint16 Guikit::touch_x = 0, Guikit::touch_y = 0;
uint16 Guikit::previous_touch_x = 0, Guikit::previous_touch_y = 0;

void Guikit::dmaFill32(const u32 fill, void * dest, u32 size) {
    DMA_SRC(3) = (u32)&fill;
    DMA_DEST(3) = (u32)dest;
    DMA_CR(3) = DMA_COPY_WORDS | DMA_SRC_FIX | (size >> 2);
    while(DMA_CR(3) & DMA_BUSY)
        /* DO NOTHING */;
}

void Guikit::vblankSleep(int vblanks) {
    for(int i = 0; i < vblanks; i++) {
        swiWaitForVBlank();
    }
}

void Guikit::rtcSleep(int seconds) {
    //as of lib nds r20, IPC is defunct, so no time for us
    /*
    //thanks to Poffy
    int secs;
    secs = IPC->curtime[7];
    int new_secs;
    new_secs = secs + seconds;
    
    if (new_secs > 59) {
        new_secs = new_secs - 60;
    }
    
    while (new_secs != secs) {
        secs = IPC->curtime[7];
    }
     */
}

void Guikit::calcFPS(double & fps, double & counter, double & seconds) {
    //as of lib nds r20, IPC is defunct, so no time for us
    /*
    if (seconds == IPC->curtime[7]) {
        counter++;
    } else {
        fps = counter/1;
        //printf("FPS: %f\n", counter/1);
        counter = 0;
        seconds = IPC->curtime[7];
    }
    */
}

void Guikit::exitToLoader() {
    //make this function accept a parameter
    //an enum for loaders
    //different loaders may have different exit code
    //we should have at least GBAMP and DARKAIN
    
    //*****  For GBAMP Exit to Loader ********
    
    /*
     16:51 <SaTa_M3SD> Patater: see code FINE or RAIN  launccchnds.cpp
     16:51 >Patater< thanks sata
     16:49 <Nikolas> so Patater, you just replace this int handle = FAT_fopen(fn, "R"); with FAT_FILE* BootLoader = FAT_fopen("/_BOOT_MP.nds","r");
     16:50 >Patater< thanks
     
     */
    
    //set execution point to main booter thingy and exit to gbamp
    //ARM9 code
    
    //XXX TODO - Update to work with libfat
    /*
    FILE * bootLoader = fopen("/_BOOT_MP.nds", "r");
    u32 fileCluster = FAT_GetFileCluster(); //get file cluster for current file
    FAT_fclose(bootLoader); //close the file
    FAT_FreeFiles(); //close filesystem (needed or no?)
    
    // Use this code to start an NDS file
    REG_IME = IME_DISABLE;  // Disable interrupts
    //WAIT_CR |= (0x8080);  // ARM7 has access to GBA cart (WinterMute says this is wrong and will cause problems with audio. 0x8000 sets bus priority to arm9.)
    //WinterMute says to use
    sysSetCartOwner(false);
    *((vu32*)0x027FFFFC) = fileCluster;  // Start cluster of NDS to load
    *((vu32*)0x027FFE04) = (u32)0xE59FF018;  // ldr pc, 0x027FFE24
    *((vu32*)0x027FFE24) = (u32)0x027FFE04;  // Set ARM9 Loop address
    swiSoftReset();  // Reset
     */
    //**********************************************************************
    
     
     
    //*****  For Darkain's Multi-NDS Exit to Loader ********
    //blank for now
    
    //**********************************************************************
}

void Guikit::bootNDS(std::string filename) {
    //not yet implemented
    return;
}

void Guikit::updateInput() {
    scanKeys();
    
    //keep track of the last place touched so that touch up events can have location data
    previous_touch_x = touch_x;
    previous_touch_y = touch_y;
    
    touch_x = IPC->touchXpx;
    touch_y = IPC->touchYpx;
    temp = IPC->temperature;
}

void Guikit::waitForTouch() {
    updateInput();
    while (!(keysDown() & KEY_TOUCH)) {
        //example: display splash until the touchpad is tapped
        updateInput();
        swiWaitForVBlank();
    }
}

UIEvent * Guikit::handleInput() {
    //translates input into events
    
    
    //touch events take priority over key events
    if (keysDown() & KEY_TOUCH) {
        //generate touch event
        //consolePrintf("TouchDown Event Generated\n");
        return new TouchEvent(STATUS_DOWN, touch_x, touch_y); //memory leaks, yay -- to address this issue, create the rule that if you handle the event (and you don't pass it on), you destroy it
    } else if (keysHeld() & KEY_TOUCH) {
        //generate touch event
        //consolePrintf("TouchHeld Event Generated\n");
        return new TouchEvent(STATUS_HELD, touch_x, touch_y); //memory leaks, yay -- to address this issue, create the rule that if you handle the event (and you don't pass it on), you destroy it
    } else if (keysUp() & KEY_TOUCH) {
        //give the last place touched for this event when generating
        //generate touch event
        //consolePrintf("TouchUp Event Generated\n");
        return new TouchEvent(STATUS_UP, previous_touch_x, previous_touch_y); //memory leaks, yay -- to address this issue, create the rule that if you handle the event (and you don't pass it on), you destroy it
    }
    
    //Feel free to create whatever muli-key events or handlers here (where they take priority over other single keys.)
    //The more complex it is (more buttons it takes into account), the higher up in this function it should go
    
    //exit back to loader code: press select and start to exit back to the Darkain MultiNDSloader
    /*if ((keysHeld() & KEY_SELECT) && (keysHeld() & KEY_START)) {
    WAIT_CR &= ~0x8080;
    LOADNDS->ARM9FUNC(BOOT_NDS);
    }*/
    
    //debug event (don't repeatedly signal to debug)
    if (((keysDown() & KEY_SELECT) && (keysHeld() & KEY_L) && (keysHeld() & KEY_R)) ||
        ((keysHeld() & KEY_SELECT) && (keysDown() & KEY_L) && (keysHeld() & KEY_R)) ||
        ((keysHeld() & KEY_SELECT) && (keysHeld() & KEY_L) && (keysDown() & KEY_R))) {
        
        return new KeyEvent(STATUS_HELD, TYPE_DEBUG);
    }
    
    //custom special key event (don't repeadedly signal to quit)
    if (((keysDown() & KEY_SELECT) && (keysHeld() & KEY_START)) ||
        ((keysHeld() & KEY_SELECT) && (keysDown() & KEY_START))) {
        return new KeyEvent(STATUS_HELD, TYPE_SPECIAL);
    }
    
    //up
    if (keysDown() & KEY_UP) {
        return new KeyEvent(STATUS_DOWN, TYPE_UP);
    } else if (keysHeld() & KEY_UP) {
        return new KeyEvent(STATUS_HELD, TYPE_UP);
    } else if (keysUp() & KEY_UP) {
        return new KeyEvent(STATUS_UP, TYPE_UP);
    }
    
    //down
    if (keysDown() & KEY_DOWN) {
        return new KeyEvent(STATUS_DOWN, TYPE_DOWN);
    } else if (keysHeld() & KEY_DOWN) {
        return new KeyEvent(STATUS_HELD, TYPE_DOWN);
    } else if (keysUp() & KEY_DOWN) {
        return new KeyEvent(STATUS_UP, TYPE_DOWN);
    }
    
    //left
    if (keysDown() & KEY_LEFT) {
        return new KeyEvent(STATUS_DOWN, TYPE_LEFT);
    } else if (keysHeld() & KEY_LEFT) {
        return new KeyEvent(STATUS_HELD, TYPE_LEFT);
    } else if (keysUp() & KEY_LEFT) {
        return new KeyEvent(STATUS_UP, TYPE_LEFT);
    }
    
    //right
    if (keysDown() & KEY_RIGHT) {
        return new KeyEvent(STATUS_DOWN, TYPE_RIGHT);
    } else if (keysHeld() & KEY_RIGHT) {
        return new KeyEvent(STATUS_HELD, TYPE_RIGHT);
    } else if (keysUp() & KEY_RIGHT) {
        return new KeyEvent(STATUS_UP, TYPE_RIGHT);
    }
    
    //a
    if (keysDown() & KEY_A) { 
        return new KeyEvent(STATUS_DOWN, TYPE_A);
    } else if (keysHeld() & KEY_A) {
        return new KeyEvent(STATUS_HELD, TYPE_A);
    } else if (keysUp() & KEY_A) {
        return new KeyEvent(STATUS_UP, TYPE_A);
    }
    
    //b
    if (keysDown() & KEY_B) { 
        return new KeyEvent(STATUS_DOWN, TYPE_B);
    } else if (keysHeld() & KEY_B) {
        return new KeyEvent(STATUS_HELD, TYPE_B);
    } else if (keysUp() & KEY_B) {
        return new KeyEvent(STATUS_UP, TYPE_B);
    }
    
    //x
    if (keysDown() & KEY_X) {
        return new KeyEvent(STATUS_DOWN, TYPE_X);
    } else if (keysHeld() & KEY_X) {
        return new KeyEvent(STATUS_HELD, TYPE_X);
    } else if (keysUp() & KEY_X) {
        return new KeyEvent(STATUS_UP, TYPE_X);
    }
    
    //y
    if (keysDown() & KEY_Y) {
        return new KeyEvent(STATUS_DOWN, TYPE_Y);
    } else if (keysHeld() & KEY_Y) {
        return new KeyEvent(STATUS_HELD, TYPE_Y);
    } else if (keysUp() & KEY_Y) {
        return new KeyEvent(STATUS_UP, TYPE_Y);
    }
    
    //l
    if (keysDown() & KEY_L) {
        return new KeyEvent(STATUS_DOWN, TYPE_L);
    } else if (keysHeld() & KEY_L) {
        return new KeyEvent(STATUS_HELD, TYPE_L);
    } else if (keysUp() & KEY_L) {
        return new KeyEvent(STATUS_UP, TYPE_L);
    }
    
    //r
    if (keysDown() & KEY_R) {
        return new KeyEvent(STATUS_DOWN, TYPE_R);
    } else if (keysHeld() & KEY_R) {
        return new KeyEvent(STATUS_HELD, TYPE_R);
    } else if (keysUp() & KEY_R) {
        return new KeyEvent(STATUS_UP, TYPE_R);
    }
    
    //select
    if (keysDown() & KEY_SELECT) {
        return new KeyEvent(STATUS_DOWN, TYPE_SELECT);
    } else if (keysHeld() & KEY_SELECT) {
        return new KeyEvent(STATUS_HELD, TYPE_SELECT);
    } else if (keysUp() & KEY_SELECT) {
        return new KeyEvent(STATUS_UP, TYPE_SELECT);
    }
    
    //start
    if (keysDown() & KEY_START) {
        return new KeyEvent(STATUS_DOWN, TYPE_START);
    } else if (keysHeld() & KEY_START) {
        return new KeyEvent(STATUS_HELD, TYPE_START);
    } else if (keysUp() & KEY_START) {
        return new KeyEvent(STATUS_UP, TYPE_START);
    }
    
    //lid is down reserved for sleeping (handlers in the arm7)
    //if (keysDown() & KEY_LID) {
    
    //}
    
    //idle, so return NULL
    return NULL;
}

