/**
 *  HotSpot.cpp
 *  
 *
 *  Created by Jaeder Patater on 8/5/05.
 *  Copyright 2005. All rights reserved.
 *
 */

#include "HotSpot.h"


void HotSpot::init(const HotSpot & other) {
    x = other.x;
    y = other.y;
    height = other.height;
    width = other.width;
}

HotSpot::HotSpot(uint16 _x, uint16 _y, uint16 _width, uint16 _height) : UIElement() {
    x = _x;
    y = _y;
    width = _width;
    height = _height;
    focusable = true;
}

HotSpot::HotSpot() : UIElement() {
    x = 0;
    y = 0;
    height = 0;
    width = 0;
    focusable = true;
}

HotSpot::HotSpot(const HotSpot & other) : UIElement(other) {
    //maintaining focus ability is handled by UIElement copy constructor
    init(other);
}

HotSpot::~HotSpot() {
    //nothing
}

HotSpot HotSpot::operator=(const HotSpot & other) {
    UIElement::operator=(other);
    //maintaining focus ability is handled by UIElement = operator
    
    init(other);
    
    return *this;
}

uint16 HotSpot::getX() const {
    return x;
}

uint16 HotSpot::getY() const {
    return y;
}

uint16 HotSpot::getWidth() const {
    return width;
}

uint16 HotSpot::getHeight() const {
    return height;
}

void HotSpot::setX(uint16 _x) {
    x = _x;
}

void HotSpot::setY(uint16 _y) {
    y = _y;
}

void HotSpot::setWidth(uint16 _width) {
    width = _width;
}

void HotSpot::setHeight(uint16 _height) {
    height = _height;
}

void HotSpot::handleTouch(TouchEvent * touchEvent) {
    //nothing
}

void HotSpot::recieveEvent(UIEvent * event) {
    if (event->getType() == TYPE_TOUCH) {
        handleTouch((TouchEvent *)event);
    }// else {
        //not a touch, so ignore
        //this event shouldn't ever occur with a hotspot (probably an issue with the UIManager or the programmer)
    //}
}

