/**
 *  MenuScreen.cpp
 *  
 *
 *  Created by Jaeder Patater on 11/7/05.
 *  Copyright 2005. All rights reserved.
 *
 */

#include "MenuScreen.h"

//strcmp and such
#include <string.h>

MenuScreen::MenuScreen(ScreenType _screenType, ScreenMode _screenMode) : SplashScreen(_screenType, _screenMode) {
    //nothing
}

MenuScreen::MenuScreen() : SplashScreen() {
    //nothing
}

MenuScreen::MenuScreen(const MenuScreen & other) : SplashScreen(other) {
    //nothing
}

MenuScreen::~MenuScreen() {
    //nothing
}


MenuScreen MenuScreen::operator=(const MenuScreen & other) {
    SplashScreen::operator=(other);
    return *this;
}

void MenuScreen::addButton(Button * button) {
    addElement(button); //don't use the element list directly. if you do, the element's parent container won't be set automatically.
}

void MenuScreen::removeButton(Button * button) {
    removeElement(button);
}

void MenuScreen::clearButtons() {
    elementList->clear();
}

Button * MenuScreen::findButton(char * name) {
    //kinda dangerous to cast all elements pulled from the list as Button objects
    //perhaps we can add a property in UIElement specifying element type, so we can know whether or not it is safe to cast
    //also, I'm sure many other programmers have come up with generic ways in C++ to determine if an object is of a certain type before casting it as that type
    //in fact, I think that I knew a generic method or two at one point, but never had to use it, so forgot
    
    if (elementList->get(0) != NULL) { //if the list is not empty
        for (int i = 0; i < elementList->getSize(); i++) { //starting at index 0, look through the list
            if (strcmp(((Button *)(elementList->get(i)))->getName(), name) == 0) { //if any button in the list has a name matching the one specified
                return (Button *)(elementList->get(i)); //return that button
            }
        }
    }
        
    return NULL; //not found, so return NULL
}

Button * MenuScreen::findButton(char * name, Button * button) {
    //kinda dangerous to cast all elements pulled from the list as Button objects
    //perhaps we can add a property in UIElement specifying element type, so we can know whether or not it is safe to cast
    //also, I'm sure many other programmers have come up with generic ways in C++ to determine if an object is of a certain type before casting it as that type
    //in fact, I think that I knew a generic method or two at one point, but never had to use it, so forgot
    
    if ((elementList->get(0) != NULL) && (elementList->find(button) != -1)) { //if the list is not empty and the specified button is in the list
        for (int i = elementList->find(button); i < elementList->getSize(); i++) { //starting at the index of the specified button, look through the list
            if (strcmp(((Button *)(elementList->get(i)))->getName(), name) == 0) { //if any button in the list has a name matching the one specified
                return (Button *)(elementList->get(i)); //return that button
            }
        }
    }
    
    return NULL; //not found, so return NULL
}

/**
 *  MenuScreen::performAutoLayout()
 *
 *  Changes all the Button object positions and/or sizes in an organized manner.
 *
 */
//void MenuScreen::performAutoLayout();

/**
 *  MenuScreen::performAutoLayout(uint8 borderSpace)
 *
 *  Changes all the Button object positions and/or sizes in an organized manner with the specified border spacing (i.e. each button would be 10 px apart on all sides 'if (borderSpace == 10px)')
 *
 */
//void MenuScreen::performAutoLayout(uint8 borderSpace);

/**
 *  MenuScreen::paint()
 *
 *  Place code that paints the splash screen here.
 *
 *  Basic formula for splash and menu screens:
 *  paint backdrop, then paint contained elements (paintContainedElements())
 *
 */
void MenuScreen::paint() {
    //nothing
}

