/**
 *  TouchEvent.cpp
 *  
 *
 *  Created by Jaeder Patater on 8/5/05.
 *  Copyright 2005. All rights reserved.
 *
 */

#include "TouchEvent.h"

void TouchEvent::init(const TouchEvent & other) {
    UIEvent::init(other); //super.init(other)
    x = other.x;
    y = other.y;
}

TouchEvent::TouchEvent(UIEventStatus _status, uint16 _x, uint16 _y) {
    type = TYPE_TOUCH;
    status = _status;
    x = _x;
    y = _y;
}

TouchEvent::TouchEvent() {
    type = TYPE_TOUCH;
}

TouchEvent::TouchEvent(const TouchEvent & other) {
    type = TYPE_TOUCH;
    init(other);
}

TouchEvent::~TouchEvent() {
    //nothing
    return;
}

TouchEvent TouchEvent::operator=(const TouchEvent & other) {
    init(other);
    return *this;
}

uint16 TouchEvent::getX() const {
    return x;
}

uint16 TouchEvent::getY() const {
    return y;
}

