/**
 *  UIEvent.cpp
 *  
 *
 *  Created by Jaeder Patater on 7/28/05.
 *  Copyright 2005 PataterSoft. All rights reserved.
 *
 */

#include "UIEvent.h"

void UIEvent::init(const UIEvent & other) {
    type = other.type;
    status = other.status;
}

UIEvent::UIEvent() {
    //nothing
}

UIEvent::UIEvent(const UIEvent & other){
    init(other);
}

void UIEvent::operator=(const UIEvent & other) {
    init(other);
}

bool UIEvent::operator==(const UIEvent & other) const {
    return ((type == other.type) && (status == other.status));
}

UIEvent::~UIEvent() {
    //nothing
}

UIEventType UIEvent::getType() const {
    return type;
}

UIEventStatus UIEvent::getStatus() const {
    return status;
}

